﻿package com.callystro.engine {

	import flash.display.MovieClip;
	import flash.display.*;
	import flash.system.*;
	import flash.utils.getDefinitionByName;
	import flash.utils.getQualifiedClassName;
	import flash.filters.GlowFilter;
	import flash.filters.BitmapFilterQuality;
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.net.*;
	import flash.events.*;
	import flash.events.ProgressEvent;
	import flash.events.MouseEvent;
	import flash.media.Sound;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.external.ExternalInterface;
	import flash.ui.*;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundMixer;

	import com.callystro.engine.Constants;
	import com.callystro.resource.MultipleResourceLoader;
	import com.callystro.resource.ResourceContainer;
	import com.callystro.resource.ResourceManager;
	import com.callystro.utils.Util;
	import com.callystro.utils.Mediator;
	import com.callystro.sound.SoundPlayer;
	import com.callystro.mochi.as3.*;

	public class GameLoader extends MovieClip {

		public var userName:String = "";
		public var DOB:String = "";
		public var gender:String = "";
		public var poosos:int;
		public var gameURL:String = "";
		public var resourceURL:String = "";

		public var environment:String = "";
		private var details:String = "";
		private var phpLoader:URLLoader;
		private var phpVars:URLVariables;
		private var phpFileRequest:URLRequest;
		public var resourcePath:String;
		private var jsArgument:String;
		private var owner:MovieClip;
		private var preLoadMc:MovieClip;
		private var _swfLoader:Loader;
		private var _swfContent:MovieClip;
		private var my_copyright:ContextMenuItem;
		private var my_menu:ContextMenu;
		private var backgroundSound:Sound;
		private var Level:int = 1;
		public var allLanguageAvailable:Boolean;
		private var languageSelectionScreenView:MovieClip;

		public function GameLoader(timeLine:MovieClip) {
			this.owner = timeLine;
			try {
				trace("Checking Environment on Web");
				environment = ExternalInterface.call("GetApp");
			} catch (error:Error) {
				trace("Checking Environment on Device");

				var myString:String = String(flash.system.Capabilities.version);
				myString = (myString).substring(0, 3);

				if ((myString == "AND") && (Capabilities.touchscreenType == TouchscreenType.FINGER || Capabilities.touchscreenType == TouchscreenType.STYLUS)) {
					environment = "Android";
				} else if (myString == "MAC") {
					environment = "IOS";
				} else {
					environment = null;
				}
			}
		}

		public function getEngine(level:int, languageAvailable:Boolean) {
			trace("Environment is  :" + environment);
			Level = level;
			allLanguageAvailable = languageAvailable;
			if (environment == "Mapoosa") {
				resourcePath = "./Resources/English/Resources.xml";
				loadSWF("libraries/MapoosaPreLoader.swf");
			} else {
				//if(allLanguageAvailable)
				//{
				//try
				//{
				//languageSelectionScreenView = new LanguageSelectionScreenView();
				//owner.addChild(languageSelectionScreenView);
				//languageSelectionScreenView.englishButton.addEventListener(MouseEvent.CLICK,languageSelected);
				//languageSelectionScreenView.hindiButton.addEventListener(MouseEvent.CLICK,languageSelected);
				//}
				//catch(error:Error)
				//{
				//trace("error-->"+error);
				//}
				//}
				//else
				//{
				//trace("No Hindi");
				resourcePath = "./Resources/English/Resources.xml";
				loadSWF("../com/callystro/engine/Swfs/CobelsPreLoader.swf");
					//}
			}
		}

		private function languageSelected(e:Event):void {
			languageSelectionScreenView.englishButton.removeEventListener(MouseEvent.CLICK, languageSelected);
			languageSelectionScreenView.hindiButton.removeEventListener(MouseEvent.CLICK, languageSelected);
			if (e.currentTarget == languageSelectionScreenView.englishButton) {
				resourcePath = "./Resources/English/Resources.xml";
			} else if (e.currentTarget == languageSelectionScreenView.hindiButton) {
				resourcePath = "./Resources/Hindi/Resources.xml";
			}
			owner.removeChild(languageSelectionScreenView);
			languageSelectionScreenView = null;
			loadSWF("../../com/callystro/engine/Swfs/CobelsPreLoader.swf");
		}

		private function loadSWF(path:String):void {
			var _req:URLRequest = new URLRequest();
			_req.url = path;
			_swfLoader = new Loader();
			setupListeners(_swfLoader.contentLoaderInfo);
			_swfLoader.load(_req);
		}

		private function setupListeners(dispatcher:IEventDispatcher):void {
			dispatcher.addEventListener(IOErrorEvent.IO_ERROR, handleMyIOError);
			dispatcher.addEventListener(Event.COMPLETE, addSWF);
		}

		private function handleMyIOError(event:IOErrorEvent):void {
			trace("Load failed: IO error: " + event.text);
		}

		private function addSWF(event:Event):void {
			event.target.removeEventListener(Event.COMPLETE, addSWF);
			_swfContent = event.currentTarget.content as MovieClip;
			if (environment != "Mapoosa") {
				event.currentTarget.content.scaleX = owner.stage.stageWidth / _swfLoader.contentLoaderInfo.width;
				event.currentTarget.content.scaleY = owner.stage.stageHeight / _swfLoader.contentLoaderInfo.height;
			}
			owner.addChild(_swfContent);
			if (_swfContent) {
				preLoaderAdded();
			}
		}

		public function preLoaderAdded() {
			trace("LoadResource");
			if (environment == "Mapoosa") {
				phpVars = new URLVariables();
				phpFileRequest = new URLRequest("./php/getUserDet.php");
				phpFileRequest.method = URLRequestMethod.POST;
				phpFileRequest.data = phpVars;
				phpLoader = new URLLoader();
				phpLoader.dataFormat = URLLoaderDataFormat.VARIABLES;
				phpLoader.addEventListener(Event.COMPLETE, showResult);
				phpVars.uName = "Me";
				phpLoader.load(phpFileRequest);
			} else if (environment == "Cobels") {
				//showAdd(true);
				ResourceManager.getInstance().addEventListener(ResourceManager.INITIALIZED, onResourceManagerInitializationComplete);
				ResourceManager.getInstance().addEventListener(ResourceManager.ERROR, onResourceManagerInitializationError);
				ResourceManager.getInstance().initialize(resourcePath);
				details = ExternalInterface.call("GetUserDet");
				var userDetails:Array = details.split("|");
				userName = userDetails[0];
				DOB = userDetails[1];
				gender = userDetails[2];
			} else {
				trace("resource");
				ResourceManager.getInstance().addEventListener(ResourceManager.INITIALIZED, onResourceManagerInitializationComplete);
				ResourceManager.getInstance().addEventListener(ResourceManager.ERROR, onResourceManagerInitializationError);
				ResourceManager.getInstance().initialize(resourcePath);
			}
		}

		public function showResult(event:Event):void {
			phpLoader.removeEventListener(Event.COMPLETE, showResult);
			userName = event.target.data.uname;
			DOB = event.target.data.dob;
			gender = event.target.data.sex;
			poosos = event.target.data.poosos;
			gameURL = event.target.data.gameURL;
			var count:int = gameURL.lastIndexOf("/");
			resourceURL = gameURL.slice(0, count + 1);
			ResourceManager.getInstance().addEventListener(ResourceManager.INITIALIZED, onResourceManagerInitializationComplete);
			ResourceManager.getInstance().addEventListener(ResourceManager.ERROR, onResourceManagerInitializationError);
			ResourceManager.getInstance().setAdditionalRelativePath(resourceURL);
			ResourceManager.getInstance().initialize(resourcePath);
		}

		public function onResourceManagerInitializationComplete(e:Event) {
			ResourceManager.getInstance().removeEventListener(ResourceManager.INITIALIZED, onResourceManagerInitializationComplete);
			ResourceManager.getInstance().removeEventListener(ResourceManager.ERROR, onResourceManagerInitializationError);
			ResourceManager.getInstance().addEventListener(Event.COMPLETE, onLoadComplete);
			ResourceManager.getInstance().addEventListener(IOErrorEvent.IO_ERROR, onResourceManagerInitializationError);
			ResourceManager.getInstance().addEventListener(ProgressEvent.PROGRESS, onResourceManagerProgress);
			ResourceManager.getInstance().load([Level]);
		}

		public function onResourceManagerProgress(e:ProgressEvent) {
			var _perc:int = (e.bytesLoaded / e.bytesTotal) * 100;
			_swfContent.bar_mc.gotoAndStop(Math.round(_perc));
			_swfContent.progressText.text = String(_perc) + "%";
		}

		public function onLoadComplete(e:Event) {
			trace("onLoadComplete");
			ResourceManager.getInstance().removeEventListener(ProgressEvent.PROGRESS, onResourceManagerProgress);
			ResourceManager.getInstance().removeEventListener(Event.COMPLETE, onLoadComplete);

			owner.removeChild(_swfContent);
			_swfContent = null;
			_swfLoader = null;
			owner.gotoAndStop(2);
			try {
				SoundPlayer.configure(SoundPlayer.PRIORITY_STOP_PLAYBACK_SOUND_MANAGEMENT);
				backgroundSound = new BackgroundSound();
				SoundPlayer.playBackGroundMusic(backgroundSound, 0.5);
			} catch (error:Error) {
				trace("error--->" + error);
			}
		}

		public function onResourceManagerInitializationError(e:Event):void {
			trace("Unable to Load Resources");
		}

		public function showAdd(display:Boolean):void {
			if (display) {
				MochiAd.showPreGameAd({clip: root, id: "221d0f039719e674", res: "765x478", background: 0xFFFFC9, color: 0xFF8A00, outline: 0xD58B3C, no_bg: false});
				MochiServices.connect("221d0f039719e674", root);
			}
		}

		public function stopGameSound(typeKey:Boolean):void {
			if (typeKey) {
				SoundPlayer.stopBackGroundMusic();
				SoundPlayer.configure(SoundPlayer.NON_PRIORITY_SOUND_MANAGEMENT);
			} else {
				SoundMixer.stopAll();
				backgroundSound = null;
			}
		}
	}
}