﻿package com.callystro.engine{
	
	import flash.display.SimpleButton;
	import flash.utils.getDefinitionByName;
	import flash.utils.getQualifiedClassName;
	import flash.filters.GlowFilter;
	import flash.filters.BitmapFilterQuality;
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.events.MouseEvent;
	import flash.media.Sound;

	
	import com.callystro.engine.Constants;
	import com.callystro.resource.MultipleResourceLoader;
	import com.callystro.resource.ResourceContainer;
	import com.callystro.resource.ResourceManager;
	import com.callystro.sound.SoundPlayer;
	
	public class VoiceOverSimpleButton extends SimpleButton {
		
		private var voiceOver:Sound;
		private var clickSound:Sound;
		private var voiceOverKey:String;
		
		public function init(voiceOverKey:String = null):void
		{
			clickSound = ResourceManager.getInstance().getSound("ClickSound");
			this.voiceOverKey = voiceOverKey;
						
			intTextAndVoiceOver();
			if(voiceOverKey && voiceOverKey != "")
			{
				this.addEventListener(MouseEvent.MOUSE_OVER, playVoiceOver);
				this.addEventListener(MouseEvent.MOUSE_OUT, stopVoiceOver);
			}
			this.addEventListener(MouseEvent.CLICK, onClick);
		}
		
		protected function intTextAndVoiceOver(e:Event = null):void
		{
			if(voiceOverKey && voiceOverKey != "")
			{
				voiceOver = ResourceManager.getInstance().getSound(voiceOverKey);
			}
		}
		
		protected function playVoiceOver(e:Event = null):void
		{
			SoundPlayer.play(voiceOverKey,voiceOver);
		}
		
		protected function stopVoiceOver(e:Event = null):void
		{
			SoundPlayer.stop(voiceOverKey);
		}
		
		protected function onClick(e:Event):void
		{
			SoundPlayer.play("ClickSound",clickSound);
		}
		
		public function dispose():void
		{
			this.removeEventListener(MouseEvent.MOUSE_OVER, playVoiceOver);
			this.removeEventListener(MouseEvent.MOUSE_OUT, stopVoiceOver);
			this.removeEventListener(MouseEvent.CLICK, onClick);
			clickSound = null;
		}
		
	}
}