﻿package com.callystro.resource {
	
	import flash.display.Loader;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.media.Sound;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.text.Font;
	
	public class FontResourceLoader extends ResourceLoader {
		
		protected var loader:Loader;
		
		public function FontResourceLoader(resource:FontResource){
			super(resource);
			loader = new Loader();
			loader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS,calculateFractionComplete);
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE,loadComplete);
			loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR,loadError);
			loader.load(new URLRequest(fontResource.url));
		}
		
		override protected function loadComplete(e:Event):void{
			fontResource.fontClass = loader.contentLoaderInfo.applicationDomain.getDefinition(fontResource.fontClassName) as Class;
			if(fontResource.autoRegister){
				Font.registerFont(fontResource.fontClass);
			}
			super.loadComplete(e);
		}
		
		override public function dispose():void {
			if(loader != null){
				loader.contentLoaderInfo.removeEventListener(ProgressEvent.PROGRESS,calculateFractionComplete);
				loader.contentLoaderInfo.removeEventListener(Event.COMPLETE,loadComplete);
				loader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR,loadError);
			}
			loader = null;
			super.dispose();
		}
		
		protected function get fontResource():FontResource {
			return resource as FontResource;
		}
		
	}

}