﻿package com.callystro.resource{
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.IEventDispatcher;
	import flash.events.ProgressEvent;
	import flash.events.TimerEvent;
	import flash.utils.Timer;
    import flash.events.IOErrorEvent;
	
	public class MultipleResourceLoader implements IEventDispatcher {       
		
		private var dispatcher:EventDispatcher;
		
		private var resourceLoaders:Array;
		
		private var resources:Array;
		
		private var timer:Timer;
		
		public function MultipleResourceLoader() {
			dispatcher = new EventDispatcher(this);
		}
			   
		public function addEventListener(type:String, listener:Function, useCapture:Boolean = false, priority:int = 0, useWeakReference:Boolean = false):void{
			dispatcher.addEventListener(type, listener, useCapture, priority);
		}
			   
		public function dispatchEvent(evt:Event):Boolean{
			return dispatcher.dispatchEvent(evt);
		}
		
		public function hasEventListener(type:String):Boolean{
			return dispatcher.hasEventListener(type);
		}
		
		public function removeEventListener(type:String, listener:Function, useCapture:Boolean = false):void{
			dispatcher.removeEventListener(type, listener, useCapture);
		}
					   
		public function willTrigger(type:String):Boolean {
			return dispatcher.willTrigger(type);
		}
		
		public function load():void {
			var resourceLoader:ResourceLoader;
			var completeEvent:Event;
			resourceLoaders = new Array();
			if(resources != null && resources.length > 0){
				for(var i:int = 0; i < resources.length; i++){
					if(resources[i] is SWFResource){
						resourceLoader = new SWFResourceLoader(resources[i] as SWFResource);
					}else if(resources[i] is FontResource){
						resourceLoader = new FontResourceLoader(resources[i] as FontResource);
					}else if(resources[i] is StyleSheetResource){
						resourceLoader = new StyleSheetResourceLoader(resources[i] as StyleSheetResource);
					}else if(resources[i] is SoundResource){
						resourceLoader = new SoundResourceLoader(resources[i] as SoundResource);
					}else if(resources[i] is XMLResource){
						resourceLoader = new XMLResourceLoader(resources[i] as XMLResource);
					}
					resourceLoaders.push(resourceLoader);
				}
				timer = new Timer(10,0);
				timer.addEventListener(TimerEvent.TIMER,updateProgress);
				timer.start();
			} else {
				trace("no resourcs to load");
				completeEvent = new Event(Event.COMPLETE,true,false);
				dispatchEvent(completeEvent);
			}
		}
		
		public function add(resource:Resource):void {
			if(resources == null){
				resources = new Array();
			}
			resources.push(resource);
		}
		
		public function dispose():void {
			disposeLoaders();
			disposeTimer();
			resources = null;
		}
		
		private function disposeTimer():void {
			if(timer != null){
				timer.removeEventListener(TimerEvent.TIMER,updateProgress);
				timer = null;
			}
		}
		
		private function disposeLoaders():void {
			if(resourceLoaders != null && resourceLoaders.length > 0){
				for(var i:int = 0; i < resourceLoaders.length ; i++){
					(resourceLoaders[i] as ResourceLoader).dispose();
				}
			}
			resourceLoaders = null;
		}
		
		private function updateProgress(e:Event):void{
			var percentComplete:Number = 0;
			var progressEvent:ProgressEvent;
			var completeEvent:Event;
			var errorEvent:IOErrorEvent;
			var complete:Boolean = true;
			var error:Boolean = false;
			if(resourceLoaders != null && resourceLoaders.length > 0){
				for(var i:int = 0; i < resourceLoaders.length; i++){
					percentComplete += (resourceLoaders[i] as ResourceLoader).fractionComplete;
					complete = (complete && ((resourceLoaders[i] as ResourceLoader).completed));
					error = (error || ((resourceLoaders[i] as ResourceLoader).errorOccured));
				}
				if(complete){
					completeEvent = new Event(Event.COMPLETE,true,false);
					timer.stop();
					disposeTimer();
					disposeLoaders();
					dispatchEvent(completeEvent);
				} else if(error){
					errorEvent = new IOErrorEvent(IOErrorEvent.IO_ERROR);
					dispatchEvent(errorEvent);
				} else {
					progressEvent = new ProgressEvent(ProgressEvent.PROGRESS,true,false,(percentComplete * 100),(resourceLoaders.length * 100));
					dispatchEvent(progressEvent);
				}
			}
		}
	}
	
}