﻿package com.callystro.resource{
	
	import flash.media.Sound;
	import flash.net.URLRequest;
	import flash.display.Loader;
	import flash.text.StyleSheet;
	import flash.text.TextFormat;
	
	public class ResourceContainer {
		
		private var textResources:Array;
		private var swfResources:Array;
		private var fontResources:Array;
		private var styleSheetResources:Array;
		private var soundResources:Array;
		private var xmlResources:Array;
		
		public var keepInMemory:Boolean = false;
		public var levelNumber:int = 0;
		public function ResourceContainer(levelResources:Object,levelNumber:int,additionalRelativePath:String,keepInMemoryFlag:Boolean = false):void {
			this.keepInMemory = keepInMemory;
			this.levelNumber = levelNumber;
			var i:int = 0;
			var textResource:TextResource;
			var swfResource:SWFResource;
			var fontResource:FontResource;
			var styleSheetResource:StyleSheetResource;
			var soundResource:SoundResource;
			var xmlResource:XMLResource;
			textResources = new Array();
			for(i = 0; i < levelResources.TextResource.length(); i++){
				textResource = new TextResource(); 
				textResource.key = levelResources.TextResource[i].@key;
				if(levelResources.TextResource[i].@value.length() > 0){
					textResource.value = levelResources.TextResource[i].@value;
				} else {
					textResource.value = levelResources.TextResource[i];
				}
				textResources.push(textResource);
			}
			swfResources = new Array();
			for(i = 0; i < levelResources.SWFResource.length(); i++){
				swfResource = new SWFResource();
				swfResource.key = levelResources.SWFResource[i].@key;
				swfResource.url = additionalRelativePath + levelResources.SWFResource[i].@url;
				if(levelResources.SWFResource[i].@preload.length() > 0){
					if(levelResources.SWFResource[i].@preload == "false"){
						swfResource.preload = false;
					}
				}
				swfResources.push(swfResource);
			}
			fontResources = new Array();
			for(i = 0; i < levelResources.FontResource.length(); i++){
				fontResource = new FontResource();
				fontResource.key = levelResources.FontResource[i].@key;
				fontResource.fontClassName = levelResources.FontResource[i].@className;
				fontResource.url = additionalRelativePath + levelResources.FontResource[i].@url;
				if(levelResources.FontResource[i].@autoRegister.length() > 0){
					if(levelResources.FontResource[i].@autoRegister == "false"){
						fontResource.autoRegister = false;
					}
				}
				fontResources.push(fontResource);
			}
			styleSheetResources = new Array();
			for(i = 0; i < levelResources.StyleSheetResource.length(); i++){
				styleSheetResource = new StyleSheetResource();
				styleSheetResource.key = levelResources.StyleSheetResource[i].@key;
				styleSheetResource.url = additionalRelativePath + levelResources.StyleSheetResource[i].@url;
				styleSheetResources.push(styleSheetResource);
			}
			soundResources = new Array();
			for(i = 0; i < levelResources.SoundResource.length(); i++){
				soundResource = new SoundResource();
				soundResource.key = levelResources.SoundResource[i].@key;
				soundResource.url = additionalRelativePath + levelResources.SoundResource[i].@url;
				if(levelResources.SoundResource[i].@preload.length() > 0){
					if(levelResources.SoundResource[i].@preload == "false"){
						soundResource.preload = false;
					}
				}
				soundResources.push(soundResource);
			}
			xmlResources = new Array();
			for(i = 0; i < levelResources.XMLResource.length(); i++){
				xmlResource = new XMLResource();
				xmlResource.key = levelResources.XMLResource[i].@key;
				xmlResource.url = additionalRelativePath + levelResources.XMLResource[i].@url;
				xmlResources.push(xmlResource);
			}
			if(levelResources.@keepInMemory.length() > 0){
				if(levelResources.@keepInMemory == "true"){
					keepInMemoryFlag = true;
				}
			}
			keepInMemory = keepInMemoryFlag;
		}
		
		public function populateResourceLoader(multipleResourceLoader:MultipleResourceLoader):void {
			var i:int = 0;
			var swfResource:SWFResource;
			var soundResource:SoundResource;
			for(i = 0; i < swfResources.length; i++){
				swfResource = swfResources[i];
				if(swfResource.preload){
					multipleResourceLoader.add(swfResource);
				}
			}
			for(i = 0; i < fontResources.length; i++){
				multipleResourceLoader.add(fontResources[i] as Resource);
			}
			for(i = 0; i < styleSheetResources.length; i++){
				multipleResourceLoader.add(styleSheetResources[i] as Resource);
			}
			for(i = 0; i < soundResources.length; i++){
				soundResource = soundResources[i];
				if(soundResource.preload){
					multipleResourceLoader.add(soundResource);
				}
			}
			for(i = 0; i < xmlResources.length; i++){
				multipleResourceLoader.add(xmlResources[i] as Resource);
			}
		}
		
		public function dispose():void {
			var i:int = 0;
			for(i = 0; i < swfResources.length; i++){
				swfResources[i].dispose();
			}
			swfResources = null;
			for(i = 0; i < fontResources.length; i++){
				fontResources[i].dispose();
			}
			fontResources = null;
			for(i = 0; i < styleSheetResources.length; i++){
				styleSheetResources[i].dispose();
			}
			styleSheetResources = null;
			for(i = 0; i < soundResources.length; i++){
				soundResources[i].dispose();
			}
			soundResources = null;
		}
		
		public function getText(key:String, textArguments:Array = null):String {
			var returnValue:String = null;
			if(textResources != null && textResources.length > 0){
				for(var i:int = 0; i < textResources.length; i++){
					if(textResources[i].key == key){
						returnValue = textResources[i].value;
						if(textArguments != null && textArguments.length > 0)
						{
							for(var j:int = 0; j < textArguments.length; j++)
							{
								returnValue = returnValue.replace("{"+j+"}", String(textArguments[j]));
							}
						}
						break;
					}
				}
			}
			return returnValue;
		}
		
		public function getSound(key:String):Sound {
			var returnValue:Sound = null;
			if(soundResources != null && soundResources.length > 0){
				for(var i:int = 0; i < soundResources.length; i++){
					if(soundResources[i].key == key){
						//Sound is not Preloaded so load it and have a Reference to it.
						if(soundResources[i].sound == null && (!soundResources[i].preload)){
							soundResources[i].sound  = new Sound(new URLRequest(soundResources[i].url));
						} 
						returnValue = soundResources[i].sound;
						break;
					}
				}
			}
			return returnValue;
		}
		
		public function getSWF(key:String):Object {
			var returnValue:Object = null;
			var loader:Loader;
			if(swfResources != null && swfResources.length > 0){
				for(var i:int = 0; i < swfResources.length; i++){
					if(swfResources[i].key == key){
						//SWF is not preloaded so load it and have a reference to it.
						if(swfResources[i].content == null && (!swfResources[i].preload)){
							loader = new Loader();
							loader.load(new URLRequest(swfResources[i].url));
							swfResources[i].content  = loader;
						} 
						returnValue = swfResources[i].content;
						break;
					}
				}
			}
			return returnValue;
		}
		
		public function getStyleSheet(key:String):StyleSheet {
			var returnValue:StyleSheet = null;
			if(styleSheetResources != null && styleSheetResources.length > 0){
				for(var i:int = 0; i < styleSheetResources.length; i++){
					if(styleSheetResources[i].key == key){
						returnValue = styleSheetResources[i].styleSheet;
						break;
					}
				}
			}
			return returnValue;
		}
		
		public function getFontClass(key:String):Class {
			var returnValue:Class = null;
			if(fontResources != null && fontResources.length > 0){
				for(var i:int = 0; i < fontResources.length; i++){
					if(fontResources[i].key == key){
						returnValue = fontResources[i].fontClass;
						break;
					}
				}
			}
			return returnValue;
		}
		
		public function getStyle(styleName:String,key:String):Object {
			var returnValue:Object = null;
			var styleSheet:StyleSheet;
			if(styleSheetResources != null && styleSheetResources.length > 0){
				for(var i:int = 0; i < styleSheetResources.length; i++){
					if(styleSheetResources[i].key == key){
						styleSheet = styleSheetResources[i].styleSheet;
						returnValue = styleSheet.getStyle(styleName);
						break;
					}
				}
			}
			return returnValue;
		}
		
		public function getTextFormat(styleName:String,key:String):TextFormat {
			var returnValue:TextFormat = null;
			var styleSheet:StyleSheet= null;
			var style:Object = null;
			if(styleSheetResources != null && styleSheetResources.length > 0){
				for(var i:int = 0; i < styleSheetResources.length; i++){
					if(styleSheetResources[i].key == key){
						styleSheet = styleSheetResources[i].styleSheet;
						style = styleSheet.getStyle(styleName);
						returnValue = styleSheet.transform(style);
						break;
					}
				}
			}
			return returnValue;
		}
		
		public function getXML(key:String):XML {
			var returnValue:XML = null;
			if(xmlResources != null && xmlResources.length > 0){
				for(var i:int = 0; i < xmlResources.length; i++){
					if(xmlResources[i].key == key){
						returnValue = xmlResources[i].xml;
						break;
					}
				}
			}
			return returnValue;
		}
		
	}

}