﻿package com.callystro.resource {
	
	import flash.display.Loader;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.media.Sound;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	public class SoundResourceLoader extends ResourceLoader {
		
		protected var loader:Sound;
		
		public function SoundResourceLoader(resource:SoundResource){
			super(resource);
			loader = new Sound();
			loader.addEventListener(ProgressEvent.PROGRESS,calculateFractionComplete);
			loader.addEventListener(Event.COMPLETE,loadComplete);
			loader.addEventListener(IOErrorEvent.IO_ERROR,loadError);
			loader.load(new URLRequest(soundResource.url));
		}
		
		override protected function loadComplete(e:Event):void{
			soundResource.sound = loader;
			super.loadComplete(e);
		}
		
		override public function dispose():void {
			if(loader != null){
				loader.removeEventListener(ProgressEvent.PROGRESS,calculateFractionComplete);
				loader.removeEventListener(Event.COMPLETE,loadComplete);
				loader.removeEventListener(IOErrorEvent.IO_ERROR,loadError);
			}
			loader = null;
			super.dispose();
		}
		
		protected function get soundResource():SoundResource {
			return resource as SoundResource;
		}
		
	}

}