﻿package com.callystro.resource {
	
	import flash.display.Loader;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.media.Sound;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.text.StyleSheet;
	
	public class StyleSheetResourceLoader extends ResourceLoader {
		
		protected var loader:URLLoader;
		
		public function StyleSheetResourceLoader(resource:StyleSheetResource){
			super(resource);
			loader = new URLLoader();
			loader.addEventListener(ProgressEvent.PROGRESS,calculateFractionComplete);
			loader.addEventListener(Event.COMPLETE,loadComplete);
			loader.addEventListener(IOErrorEvent.IO_ERROR,loadError);
			loader.load(new URLRequest(styleSheetResource.url));
		}
		
		override protected function loadComplete(e:Event):void{
			var styleSheet:StyleSheet = new StyleSheet();
			styleSheet.parseCSS(loader.data);
			styleSheetResource.styleSheet = styleSheet;
			styleSheet = null;
			super.loadComplete(e);
		}
		
		override public function dispose():void {
			if(loader != null){
				loader.removeEventListener(ProgressEvent.PROGRESS,calculateFractionComplete);
				loader.removeEventListener(Event.COMPLETE,loadComplete);
				loader.removeEventListener(IOErrorEvent.IO_ERROR,loadError);
			}
			loader = null;
			super.dispose();
		}
		
		protected function get styleSheetResource():StyleSheetResource {
			return resource as StyleSheetResource;
		}
		
	}

}