﻿package com.callystro.resource {
	
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	public class XMLResourceLoader extends ResourceLoader {
		
		protected var loader:URLLoader;
		
		public function XMLResourceLoader(resource:XMLResource){
			super(resource);
			loader = new URLLoader();
			loader.addEventListener(ProgressEvent.PROGRESS,calculateFractionComplete);
			loader.addEventListener(Event.COMPLETE,loadComplete);
			loader.addEventListener(IOErrorEvent.IO_ERROR,loadError);
			loader.load(new URLRequest(xmlResource.url));
		}
		
		override protected function loadComplete(e:Event):void{
			var xml:XML = new XML(loader.data);
			xmlResource.xml = xml;
			xml = null;
			super.loadComplete(e);
		}
		
		override public function dispose():void {
			if(loader != null){
				loader.removeEventListener(ProgressEvent.PROGRESS,calculateFractionComplete);
				loader.removeEventListener(Event.COMPLETE,loadComplete);
				loader.removeEventListener(IOErrorEvent.IO_ERROR,loadError);
			}
			loader = null;
			super.dispose();
		}
		
		protected function get xmlResource():XMLResource {
			return resource as XMLResource;
		}
		
	}

}