﻿package com.callystro.sound {
	
	public class SoundInstanceContainer{
		
		public var soundInstances:Array = new Array();
		
		public function addSoundInstance(soundInstance:SoundInstance):void {
			soundInstances.push(soundInstance);
		}
		
		public function getAllSoundInstances():Array {
			return soundInstances;
		}
		
		public function removeSoundInstance(key:String):void {
			var temp:Array = new Array();
			for(var i:int = 0; i < soundInstances.length ; i++ ){
				if(soundInstances[i].key != key){
					if(soundInstances[i].isPaused || soundInstances[i].isPlaying)
					{
						temp.push(soundInstances[i]);
					} else
					{
						soundInstances[i].dispose();
					}
				} else
				{
					soundInstances[i].dispose();
				}
			}
			soundInstances = temp;
		}
		
		public function getSoundInstance(key:String):SoundInstance {
			for(var i:int = 0; i < soundInstances.length ; i++ ){
				if(soundInstances[i].key == key){
					return (soundInstances[i] as SoundInstance);
				}
			}
			return null;
		}
		
		public function getAllPlayingSoundInstances():Array {
			var allPlayingSoundInstances:Array;
			allPlayingSoundInstances = new Array();
			for(var i:int = 0; i < soundInstances.length ; i++ ){
				if(soundInstances[i].isPlaying){
					allPlayingSoundInstances.push(soundInstances[i]);
				}
			}
			return allPlayingSoundInstances;
		}
		
		public function getAllPausedSoundInstances():Array {
			var allPausedSoundInstances:Array;
			allPausedSoundInstances = new Array();
			for(var i:int = 0; i < soundInstances.length ; i++ ){
				if(soundInstances[i].isPaused){
					allPausedSoundInstances.push(soundInstances[i]);
				}
			}
			return allPausedSoundInstances;
		}
		
		public function getCurrentHighestPriority():int {
			var currentHighestPriority:int = -1;
			for(var i:int = 0; i < soundInstances.length ; i++ ){
				if((soundInstances[i].isPlaying) && (soundInstances[i].priority > currentHighestPriority)){
					currentHighestPriority = soundInstances[i].priority;
				}
			}
			return currentHighestPriority;
		}
		
		public function getAllSoundInstancesOfPriority(priority:int):Array {
			var soundInstancesOfPriority:Array;
			soundInstancesOfPriority = new Array();
			for(var i:int = 0; i < soundInstances.length ; i++ ){
				if(soundInstances[i].priority == priority){
					soundInstancesOfPriority.push(soundInstances[i]);
				}
			}
			return soundInstancesOfPriority;
		}
	
	}
	
}