﻿package com.callystro.sound {
	
	import flash.media.Sound;
	import flash.media.SoundMixer;
	import flash.media.SoundTransform;
	import flash.media.SoundChannel;
	
	public class SoundPlayer {
		
		{
			soundInstanceContainer = new SoundInstanceContainer();
			soundManager = new SoundManager(soundInstanceContainer);
			SoundMixer.soundTransform.volume = playerVolume;
		}
		
		public static const NON_PRIORITY_SOUND_MANAGEMENT:String = "noPrioritySoundManagement";
		public static const PRIORITY_STOP_PLAYBACK_SOUND_MANAGEMENT:String = "priorityStopPlayBackSoundManagement";
		public static const PRIORITY_MUTE_PLAYBACK_SOUND_MANAGEMENT:String = "priorityMutePlayBackSoundManagement";
		
		public static var soundManagementType:String = NON_PRIORITY_SOUND_MANAGEMENT;
		
		public static var playerVolume:Number = 1;
		
		public static var allowMultipleInstanceOfSameSoundToPlayFlag:Boolean = true;
		
		private static var soundManager:SoundManager; 
		
		private static var soundInstanceContainer:SoundInstanceContainer;
		
		public static function configure(soundManagementType:String = NON_PRIORITY_SOUND_MANAGEMENT,
										 volume:Number = 1,
										 allowMultipleInstanceOfSameSoundToPlay:Boolean = true):void {
			allowMultipleInstanceOfSameSoundToPlayFlag = allowMultipleInstanceOfSameSoundToPlay;
			if(soundManager != null){
				soundManager.dispose();
			}
			switch(soundManagementType){
				case NON_PRIORITY_SOUND_MANAGEMENT : {
					soundManager = new SoundManager(soundInstanceContainer);
					break;
				}
				case PRIORITY_STOP_PLAYBACK_SOUND_MANAGEMENT : {
					soundManager = new StopPlayBackSoundManager(soundInstanceContainer);
					break;
				}
				case PRIORITY_MUTE_PLAYBACK_SOUND_MANAGEMENT : {
					soundManager = new MutePlayBackSoundManager(soundInstanceContainer);
					break;
				}
			}
			changePlayerVolume(volume);
		}
										 
		public static function play(key:String,
									sound:Sound,
									completeHandler:Function = null,
									priority:int = 0,
									repeatCount:int = 0,
									completeHandlerArguments:Array = null,
									callCompleteHandlerOnStop:Boolean = false,
									volume:Number = 1,
									callCompleteHandlerOnPrempting:Boolean= false,
									startTime:Number = 0):void {
			var soundInstance:SoundInstance = new SoundInstance();
			soundInstance.key = key;
			soundInstance.sound = sound;
			soundInstance.completeHandler = completeHandler;
			soundInstance.priority = priority;
			soundInstance.repeatCount = repeatCount;
			soundInstance.completeHandlerArguments = completeHandlerArguments;
			soundInstance.callCompleteHandlerOnStop = callCompleteHandlerOnStop;
			soundInstance.volume = volume;
			soundInstance.callCompleteHandlerOnPrempting = callCompleteHandlerOnPrempting;
			soundInstance.startTime = startTime;
			soundManager.play(soundInstance);
		}
		
		public static function playBackGroundMusic(sound:Sound,volume:Number = 0.2):void
		{
			soundManager.playBackGroundMusic(sound,volume);
		}
		
		public static function stop(key:String){
			soundManager.stop(key);
		}
		
		public static function stopAll():void {
			soundManager.stopAll();
		}
		
		public static function pauseAll():void{
			soundManager.pauseAll();
		}
		
		public static function pause(key:String):void {
			soundManager.pause(key);
		}
		
		public static function resume(key:String):void {
			soundManager.resume(key);
		}
		
		public static function resumeAll():void {
			soundManager.resumeAll();
		}
		
		public static function changePlayerVolume(volume:Number):void {
			SoundMixer.soundTransform = new SoundTransform(volume);
		}
		
		public static function changeVolume(key:String,volume:Number):void{
			soundManager.changeVolume(key,volume);
		}
		
		public static function restoreVolume(key:String):void{
			soundManager.restoreVolume(key);
		}
		
		public static function stopBackGroundMusic():void
		{
			soundManager.stopBackGroundMusic();
		}
		
	}

}
