﻿package com.callystro.sound {
	
	import flash.events.Event;
	import flash.media.Sound;
	import flash.media.SoundMixer;
	import flash.media.SoundTransform;
	import flash.media.SoundChannel;
	
	public class StopPlayBackSoundManager extends SoundManager {
			
		public function StopPlayBackSoundManager(soundInstanceContainer:SoundInstanceContainer){
			super(soundInstanceContainer);
		}
		
		override public function play(soundInstance:SoundInstance):void {
			var currentHighestPriority:int = soundInstanceContainer.getCurrentHighestPriority();
			var soundInstances:Array;
			
			if(!SoundPlayer.allowMultipleInstanceOfSameSoundToPlayFlag){
				if(soundInstanceContainer.getSoundInstance(soundInstance.key) != null){
					return;
				}
			}
			
			if(soundInstance.priority < currentHighestPriority){
				if(soundInstance.callCompleteHandlerOnStop && (soundInstance.completeHandler != null)){
					if(soundInstance.completeHandlerArguments != null){
						soundInstance.completeHandler.apply(null,soundInstance.completeHandlerArguments);
					} else {
						soundInstance.completeHandler();
					}
				}
			} else {
				if(soundInstance.priority > currentHighestPriority){
					soundInstances = soundInstanceContainer.getAllSoundInstancesOfPriority(currentHighestPriority);
					for(var i = 0; i < soundInstances.length; i++){
						soundInstances[i].stop();
					}
				}
				soundInstanceContainer.addSoundInstance(soundInstance);
				soundInstance.addEventListener(SoundInstance.SOUND_COMPLETE,soundCompleteHandler);
				soundInstance.addEventListener(SoundInstance.SOUND_STOPPED,soundStoppedHandler);
				if(backgroundMusicPlaying)
				{
					var sndTransform:SoundTransform = new SoundTransform(0.05);
					backgroundMusicChannel.soundTransform  = sndTransform;
				}
				soundInstance.play();
			}
		}
		
		override public function soundCompleteHandler(e:Event):void {
			super.soundCompleteHandler(e);
			if(backgroundMusicPlaying)
			{
				if(soundInstanceContainer.soundInstances.length == 0)
				{
					var sndTransform:SoundTransform = new SoundTransform(backgroundMusicVolume);
					backgroundMusicChannel.soundTransform  = sndTransform;
				}
			}
		}
		
		override public function soundStoppedHandler(e:Event):void {
			super.soundStoppedHandler(e);
			
			if(backgroundMusicPlaying)
			{
				if(soundInstanceContainer.soundInstances.length == 0)
				{
					var sndTransform:SoundTransform = new SoundTransform(backgroundMusicVolume);
					backgroundMusicChannel.soundTransform  = sndTransform;
				}
			}
		}
		
		
		override public function resume(key:String):void {
			var currentHighestPriority:int;
			var soundInstance:SoundInstance = soundInstanceContainer.getSoundInstance(key);
			var soundInstances:Array;
			if(soundInstance.priority < currentHighestPriority){
				if(soundInstance.callCompleteHandlerOnStop && (soundInstance.completeHandler != null)){
					if(soundInstance.completeHandlerArguments != null){
						soundInstance.completeHandler.apply(null,soundInstance.completeHandlerArguments);
					} else {
						soundInstance.completeHandler();
					}
				}
			} else {
				if(soundInstance.priority > currentHighestPriority){
					soundInstances = soundInstanceContainer.getAllSoundInstancesOfPriority(currentHighestPriority);
					for(var i = 0; i < soundInstances.length; i++){
						soundInstances[i].stop();
					}
				}
				soundInstance.resume();
			}
		}
	}
	
}