﻿package  com.callystro.timer{
	import flash.events.Event;
	import flash.events.TimerEvent;
	import flash.utils.Timer;

	public class CallBackInstance
	{
		var timer:Timer;
		var intermediateTimerCallBack:Function;
		var completeTimerCallBack:Function;
		var intermediateTimerCallBackVar:Object;
		var completeTimerCallBackVar:Object;
		var counter:int = 0;
		var isOneTime:Boolean = false;
		var isDisposed = false;
		
		public function startTimer(delay:Number,
								   repeatCount:int,
								   intermediateTimerCallBack:Function = null,
								   completeTimerCallBack:Function = null,
								   intermediateTimerCallBackVar:Object = null,
								   completeTimerCallBackVar:Object = null,
								   isOneTime:Boolean = false)
		{
			this.completeTimerCallBack = completeTimerCallBack;
			this.intermediateTimerCallBack = intermediateTimerCallBack;
			this.intermediateTimerCallBackVar = intermediateTimerCallBackVar;
			this.completeTimerCallBackVar = completeTimerCallBackVar;
			this.isOneTime = isOneTime;
			if(isOneTime)
			{
				if(delay > 100)
				{
					repeatCount = delay / 100;
					delay = 100;
				}
			}
			timer = new Timer(delay,repeatCount);
			if(repeatCount != 1)
			{
				timer.addEventListener(TimerEvent.TIMER, onTimer);
			}
			if(repeatCount != 0)
			{
				timer.addEventListener(TimerEvent.TIMER_COMPLETE, onTimerComplete);
			}
			timer.start();
		}
		
		private function onTimer(e:Event):void
		{
			if(!isOneTime)
			{
				counter++;
				if(intermediateTimerCallBack != null)
				{
					intermediateTimerCallBack(counter,intermediateTimerCallBackVar);
				}
			}
		}
		
		private function onTimerComplete(e:Event):void
		{
			var onCompleteFunction:Function = completeTimerCallBack;
			var onCompleteFunctionVars:Object = completeTimerCallBackVar;
			dispose();
			if(onCompleteFunction != null)
			{
				onCompleteFunction(counter,onCompleteFunctionVars);
			}
		}
		
		private function dispose():void
		{
			if(!isDisposed)
			{
				isDisposed = true;
				intermediateTimerCallBack = null;
				completeTimerCallBack = null;
				intermediateTimerCallBackVar = null;
				completeTimerCallBackVar = null;
				timer.stop();
				timer.removeEventListener(TimerEvent.TIMER,onTimer);
				timer.removeEventListener(TimerEvent.TIMER_COMPLETE,onTimerComplete);
				timer = null;
			}
		}
		
		public function pause():void
		{
			if(timer != null)
			{
				timer.stop();
			}
		}
		
		public function abort():void
		{
			dispose();
		}
		
		public function unPause():void
		{
			if(timer != null)
			{
				timer.start();
			}
		}
		
		public function restart():void
		{
			if(timer != null)
			{
				timer.reset();
				timer.start();
			}
		}
	}
}