﻿package com.callystro.utils{
	
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.IEventDispatcher;
	import flash.media.Sound;
	
	public class Mediator implements IEventDispatcher {
		
		private var dispatcher:EventDispatcher;
		
		private static var mediator:Mediator = null;
		
		public static function getInstance():Mediator{
			if(mediator == null){
				mediator = new Mediator();
			}
			return mediator;
		}
		
		public function Mediator(){
			dispatcher = new EventDispatcher(this);
		}
		
		public function addEventListener(type:String, listener:Function, useCapture:Boolean=false, priority:int=0, useWeakReference:Boolean=false):void {
			dispatcher.addEventListener(type, listener, useCapture, priority, useWeakReference);
		}
		
		public function removeEventListener(type:String, listener:Function, useCapture:Boolean=false):void {
			dispatcher.removeEventListener(type, listener, useCapture);
		}
		
		public function dispatchEvent(event:Event):Boolean {
			return dispatcher.dispatchEvent(event);
		}
		
		public function dispatchNotification(type:String):Boolean {
			return dispatchEvent(new Event(type));
		}
		
		public function hasEventListener(type:String):Boolean {
			return dispatcher.hasEventListener(type);
		}
		
		public function willTrigger(type:String):Boolean {
			return dispatcher.willTrigger(type);
		}
	}
}