﻿package com.callystro.utils{
	
	import flash.display.MovieClip;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.utils.getDefinitionByName;
	import flash.utils.getQualifiedClassName;
	
	import com.callystro.resource.ResourceManager;
	
	public class Util {
	
		public static function removeAllChildren(parent:MovieClip):void {
			while(parent.numChildren > 0){
				parent.removeChildAt(0);
			}
		}
		
		public static function removeAllChildrenRecursively(clip:MovieClip):void
		{
			clip.stop();
			while(clip.numChildren > 0){
				trace(clip.numChildren);
				if(clip.getChildAt(0) is MovieClip)
				{
					removeAllChildrenRecursively(clip.getChildAt(0) as MovieClip);
				}
				clip.removeChildAt(0);
			}
		}
		
		public static function getRandomizedSubset(original:Array,subsetItemsCount:int):Array {
			var intermediateArray:Array = shuffleArray(original);
			var returnArray:Array 
			if(intermediateArray != null){
				returnArray = new Array();
				for(var i:int= 0 ; ((i < intermediateArray.length) && (i < subsetItemsCount)) ; i++){
					returnArray.push(intermediateArray[i]);
				}
			}
			return returnArray;
		}
		
		public static function shuffleArray(baseArray:Array):Array {
			var fullySuffledArray:Array;
			var positionArray:Array = new Array();
			var partiallyShuffledPositionArray = new Array();
			if(baseArray != null && baseArray.length > 1){
				fullySuffledArray = new Array();
				for (var i:int = baseArray.length - 1; i >= 0; i--) {
					positionArray.push(i);
					partiallyShuffledPositionArray.push(baseArray.length - 1 - i);
				}
				positionArray = shuffle(positionArray,partiallyShuffledPositionArray);
				for (var j:int = 0; j < positionArray.length; j++) {
					fullySuffledArray.push(baseArray[positionArray[j]]);
				}
			} else {
				return baseArray;
			}
			return fullySuffledArray;
		}
		
		private static function shuffle(baseArray:Array,partiallySuffled:Array):Array {
			var noOfMatches:int=0;
			var fullySuffledArray:Array = new Array();
			
			while (partiallySuffled.length > 0) {
				var r:int = Math.floor( Math.random() * partiallySuffled.length);
				fullySuffledArray.push(partiallySuffled[r]);
				partiallySuffled.splice(r,1);
			}
			
			for (var i:int =0; i < fullySuffledArray.length; i++) {
				if (baseArray[i] == fullySuffledArray[i]) {
					noOfMatches++;
				}
			}
			if(noOfMatches > 0){
				return shuffle(baseArray,fullySuffledArray);
			} else{
				return fullySuffledArray;
			}
		}
		
		public static function getRandomNumberBetween(startBound:int,endBound:int):int {
			var randomNumber:int = startBound;
			if((startBound < endBound) && (startBound != endBound)){
				randomNumber = startBound + Math.floor(Math.random() * (endBound - startBound));
			}
			return randomNumber;
		}
		
		public static function setText(textField:TextField,
									   defaultTextFormatKey:String,
									   textKey:String = null,
									   autoSize:String = "center",
									   selectable:Boolean = false,
									   mouseEnabled:Boolean = false,
									   textAurguments:Array = null):void
		{
			textField.autoSize = autoSize;
			textField.defaultTextFormat = ResourceManager.getInstance().getTextFormat(defaultTextFormatKey,"StyleSheet");
			textField.embedFonts = true;
			textField.antiAliasType = flash.text.AntiAliasType.ADVANCED;
			textField.selectable = selectable;
			if(textKey && textKey != "")
			{
				textField.text = ResourceManager.getInstance().getText(textKey, textAurguments);
			}
			textField.mouseEnabled = mouseEnabled;
		}
		
		public static function setHtmlText(textField:TextField,
									   defaultTextFormatKey:String,
									   textKey:String = null,
									   autoSize:String = "center",
									   selectable:Boolean = false,
									   mouseEnabled:Boolean = false,
									   textAurguments:Array = null):void
		{
			textField.autoSize = autoSize;
			textField.defaultTextFormat = ResourceManager.getInstance().getTextFormat(defaultTextFormatKey,"StyleSheet");
			textField.embedFonts = true;
			textField.antiAliasType = flash.text.AntiAliasType.ADVANCED;
			textField.selectable = selectable;
			if(textKey && textKey != "")
			{
				textField.htmlText = ResourceManager.getInstance().getText(textKey, textAurguments);
			}
			textField.mouseEnabled = mouseEnabled;
		}
		
		public static function getClass(obj:Object):Class {
			return Class(getDefinitionByName(getQualifiedClassName(obj)));
		}
		
		public static function getPaddedText(value:int, length:int = 2):String
		{
			var returnValue:String = "";
			var remainder:int;
			var intermediateValue:int = Math.abs(value);
			for(var i:int = 0; (i < length || intermediateValue != 0); i ++)
			{
				remainder = intermediateValue % 10;
				returnValue = remainder + returnValue;
				intermediateValue = intermediateValue / 10;
			}
			return returnValue;
		}
	
	}
	
}